/**************************************
*
*	© trdm, as Troshin D. V. 2008
*  	GNU GPL3
*  	unNStudio project
*
***************************************/
#include "uoColorChooser.h"
#include "uoColorCContainer.h"
#include <QPainter>
#include <QBoxLayout>
#include <QApplication>
#include <QStylePainter>
#include <QKeyEvent>
#include <QPalette>
#include <QRect>
#include <QStyleOption>



uoColorChooser::uoColorChooser(QWidget *parent)
	: QFrame(parent)
{
	setMouseTracking(true); 	/// начинаем ловить перемещение мышки....
	setFocusPolicy(Qt::StrongFocus);
	m_allAddBtnSize = 0;
	m_curCtrl = 0;
	m_addBtn = 0;
	m_colorArea = QRect(0,0,0,0);

    setLineWidth(0);

    setFrameStyle(Sunken);
    setFrameShape(QFrame::StyledPanel);
    setSizePolicy(QSizePolicy::Minimum, QSizePolicy::Fixed);
    fillColors();
    m_Container = NULL;
    setupBotton();

}

uoColorCContainer*
uoColorChooser::getContainer()
{
	if (!m_Container){
		m_Container = new uoColorCContainer(this);
		if (m_Container){
		}
	}
	return m_Container;
}


uoColorChooser::~uoColorChooser()
{
	//dtor
	delete m_Container;
}
int uoColorChooser::addColor(QColor col)
{
	int retVal = -1;
	m_colorList.append(QColor(col));
	if (!m_colorCur.isValid()) {
		m_colorCur = col;
		m_colorCurPos = m_colorList.count()-1;
	}
	return m_colorList.count()-1;
}

QColor uoColorChooser::getColor(int pos)
{
	if (pos != -1) {
		if (pos<m_colorList.size())
			return m_colorList.at(pos);
	}
	return m_colorCur;
}


void uoColorChooser::fillColors(){

	m_colorList.append(QColor("#000000"));
	m_colorList.append(QColor("#ffffff"));
	m_colorList.append(QColor("#ff0000"));
	m_colorList.append(QColor("#00ff00"));
	m_colorList.append(QColor("#0000ff"));//blue
	m_colorList.append(QColor("#ffff00"));// желтый
	m_colorList.append(QColor("#ff00ff"));	//
	m_colorList.append(QColor("#00ffff"));	//

	m_colorList.append(QColor("#800000"));	//
	m_colorList.append(QColor("#008000"));	//
	m_colorList.append(QColor("#808000"));	//
	m_colorList.append(QColor("#000080"));	//
	m_colorList.append(QColor("#800080"));	//
	m_colorList.append(QColor("#008080"));	//
	m_colorList.append(QColor("#808080"));	//
	m_colorList.append(QColor("#c0c0c0"));	//

	//3
	m_colorList.append(QColor("#8080ff"));	//
	m_colorList.append(QColor("#802060"));	//
	m_colorList.append(QColor("#ffffc0"));	//
	m_colorList.append(QColor("#a0e0e0"));	//
	m_colorList.append(QColor("#600080"));	//
	m_colorList.append(QColor("#ff8080"));	//
	m_colorList.append(QColor("#0080c0"));	//
	m_colorList.append(QColor("#c0c0ff"));	//

	//4
	m_colorList.append(QColor("#00cfff"));	//
	m_colorList.append(QColor("#69ffff"));	//
	m_colorList.append(QColor("#e0ffe0"));	//
	m_colorList.append(QColor("#dd9cb3"));	//
	m_colorList.append(QColor("#b38fee"));	//
	m_colorList.append(QColor("#2a6ff9"));	//
	m_colorList.append(QColor("#3fb8cd"));	//
	m_colorList.append(QColor("#488436"));	//

	// 5
	m_colorList.append(QColor("#958c41"));	//
	m_colorList.append(QColor("#905e42"));	//
	m_colorList.append(QColor("#a0627a"));	//
	m_colorList.append(QColor("#624fac"));	//
	m_colorList.append(QColor("#1d2fbe"));	//
	m_colorList.append(QColor("#286676"));	//
	m_colorList.append(QColor("#004500"));	//
	m_colorList.append(QColor("#453e01"));	//

	// 6
	m_colorList.append(QColor("#6a2813"));	//
	m_colorList.append(QColor("#85396a"));	//
	m_colorList.append(QColor("#4a3285"));	//
	m_colorList.append(QColor("#c0dcc0"));	//
	m_colorList.append(QColor("#a6caf0"));	//
	m_colorList.append(QColor("#7fffd4"));	//
	m_colorList.append(QColor("#f0ffff"));	//
	m_colorList.append(QColor("#f5f5dc"));	///// Повтор?!
	// Повторы?!
	// 7
	m_colorList.append(QColor("#808000"));	//
	m_colorList.append(QColor("#800080"));	//
	m_colorList.append(QColor("#008080"));	//
	m_colorList.append(QColor("#808080"));	//
	m_colorList.append(QColor("#fffbf0"));	//
	m_colorList.append(QColor("#a0a0a4"));	//
	m_colorList.append(QColor("#313900"));	//
	m_colorList.append(QColor("#d9853e"));	//
}

QSize uoColorChooser::sizeHint() const{

    QFontMetrics fm(font());
    int h = qMax(fm.height(), 7)* 1.6;
    int w = fm.width(QLatin1Char('x')) * 14 + m_allAddBtnSize; // "some"
	return QSize(w,h);
}
QSize uoColorChooser::minimumSizeHint() const{
    QFontMetrics fm(font());
    int h = qMax(fm.height(), 7)*1.6;
    int w = fm.width(QLatin1Char('x')) * 14 + m_allAddBtnSize; // "some"
	return QSize(w,h);
}

int uoColorChooser::addButton(const QString& text, uoCC_Btn type)
{
	if (text.isEmpty())
		return 0;
	uoAddButton* btn = new uoAddButton;
	btn->m_text = text;
	btn->m_pressed = false;
	btn->m_Type 	= type;

	m_btns.append(btn);
	m_addBtn = m_btns.count();
}

int uoColorChooser::addButtonPrimitive(const QStyle::PrimitiveElement prim, uoCC_Btn type)
{
	if (!(
		prim == QStyle::PE_IndicatorArrowUp ||
		prim == QStyle::PE_IndicatorArrowDown||
		prim == QStyle::PE_IndicatorArrowRight||
		prim == QStyle::PE_IndicatorArrowLeft
	))
		return 0;
	uoAddButton* btn = new uoAddButton;
	btn->m_PE = prim;
	btn->m_pressed = false;
	btn->m_Type 	= type;
	m_btns.append(btn);
	m_addBtn = m_btns.count();
}


void uoColorChooser::recalcRects()
{
	m_allAddBtnSize = 0;
	if(m_btns.isEmpty())
		return;

	QRect frmRect = frameRect();
	int offTop = style()->pixelMetric(QStyle::PM_DefaultFrameWidth);

	if (!frmRect.isValid())
		return;
	QFontMetrics fm(font()); // Подрасчитаем размеры..
	frmRect.adjust(0,offTop,0,-offTop);

	uoAddButton* btn = NULL;
	QList<uoAddButton*>::iterator it = m_btns.begin();
	while(it != m_btns.end()){
		btn = *it;
		if (QStyle::PE_CustomBase == btn->m_PE) {
			btn->m_size = fm.width(btn->m_text)+4*offTop + 2;
		} else {
			btn->m_size = fm.width(QString("X"))+4*offTop + 2;
		}

		btn->m_rect = QRect(frmRect.topLeft(),frmRect.bottomLeft());
		btn->m_rect.adjust(0,0,btn->m_size,0);
		m_allAddBtnSize += 	btn->m_size;
		it++;
	}
	int endOf = frmRect.width()-(m_allAddBtnSize + offTop*m_btns.count());
	m_colorArea.setTopLeft(QPoint(offTop, offTop));
	m_colorArea.setBottomRight(QPoint(endOf, frmRect.bottom()));
	it = m_btns.begin();
	while(it != m_btns.end()){
		btn = *it;
		btn->m_rect.translate(endOf,0);
		endOf = endOf + btn->m_size + offTop;
		it++;
	}
}



void uoColorChooser::paintEvent(QPaintEvent *event)
{
    QStylePainter painter(this);
   	const QPalette palette_c = palette();

    painter.setPen(palette().color(QPalette::Text));
    // draw the combobox frame, focusrect and selected etc.

	int offTop = style()->pixelMetric(QStyle::PM_DefaultFrameWidth);

	QRect frmRect = frameRect();
//	QStyleOptionFrame opt;
    QStyleOptionComboBox opt;
    opt.initFrom(this);
    opt.frame = 1;
    opt.subControls = QStyle::SC_ComboBoxFrame;
	opt.state |= QStyle::State_Sunken;

    painter.drawComplexControl(QStyle::CC_ComboBox, opt);


	int endOf = m_allAddBtnSize + offTop*m_btns.count();

	frmRect.adjust(0,0,-endOf+offTop,0);
	QRect rectCbEdtFld = frmRect;
	opt.rect = frmRect;

//	opt.subControls = QStyle::SC_ComboBoxArrow;// | QStyle::SC_ComboBoxFrame;
//	opt.state |= QStyle::State_Sunken;
	// нужно отрисовать цвет.
//    if (m_curCtrl == 0)		opt.

//	painter.drawComplexControl(QStyle::CC_ComboBox, opt);
	if (!m_btns.isEmpty()){
		QList<uoAddButton*>::iterator it = m_btns.begin();
		uoAddButton* btn = NULL;
		int curBtn = 0;

		while(it != m_btns.end()){
			btn = *it;
			++curBtn;
			QStyleOptionButton optB;
			optB.initFrom(this);
			optB.features = QStyleOptionButton::None;

			optB.rect = btn->m_rect;
			if (btn->m_pressed){
				optB.state |= QStyle::State_Sunken;
			}
			optB.state |= QStyle::State_Raised;
			if (!(hasFocus() && m_curCtrl == curBtn)) {
				QStyle::State st = QStyle::State_HasFocus;
				st = ~st;
				optB.state = optB.state & st;
			}

			if (QStyle::PE_CustomBase == btn->m_PE) {
				optB.text = btn->m_text;
				painter.drawControl(QStyle::CE_PushButton, optB);
			} else {
				painter.drawControl(QStyle::CE_PushButton, optB);
				painter.drawPrimitive(btn->m_PE, optB);
			}
			it++;
		}
	}

//	int sizeCbBtn = style()->pixelMetric(QStyle::PM_ButtonIconSize);
//	int sizeCbEdtFld = frmRect.width() - 2*offTop - sizeCbBtn;
//	rectCbEdtFld = QRect(frmRect.topLeft(),frmRect.bottomRight());
//
//	rectCbEdtFld.adjust(offTop,offTop,-(offTop+sizeCbBtn),-offTop); // рект готов.
	rectCbEdtFld.adjust(offTop,offTop,-offTop,-offTop); // рект готов.
	if (rectCbEdtFld.isValid()){
		painter.fillRect(rectCbEdtFld,palette_c.window());
		rectCbEdtFld.adjust(offTop,offTop,-offTop,-offTop); // рект готов.
		if (rectCbEdtFld.isValid()) {
			if (hasFocus() && m_curCtrl == 0) {
				painter.setPen(Qt::DotLine);
				painter.drawRect(rectCbEdtFld);
			}
			rectCbEdtFld.adjust(offTop,offTop,-offTop,-offTop); // рект готов.
			if (rectCbEdtFld.isValid()) {
				painter.fillRect(rectCbEdtFld,QBrush(m_colorCur));
			}
		}
	}
}

void uoColorChooser::resizeEvent ( QResizeEvent * event )
{
	QFrame::resizeEvent(event);
	recalcRects();
}

void uoColorChooser::setCurentColor(int colNum)
{
	if(colNum >= 0 && colNum<m_colorList.size()){
		m_colorCur = m_colorList.at(colNum);
		m_colorCurPos = colNum;
		update();
	}
}

void uoColorChooser::checkButtonAction(uoAddButton* btn)
{
	if (btn){
		if (btn->m_PE == QStyle::PE_IndicatorArrowDown)
		{
			popupShow();
		}
	}
}


void uoColorChooser::keyPressEvent ( QKeyEvent * event )
{
	int key = event->key();
	resetButton();
	uoAddButton* btn = NULL;
	if (m_Container != NULL){
		if (m_Container->isVisible()){
			switch (key)	{
				case Qt::Key_Down:
				case Qt::Key_Up:
				case Qt::Key_Right:
				case Qt::Key_Left:	{
					(void)QApplication::sendEvent(m_Container, event);
					event->accept();
					return;
					break;
				}
				default: {
					break;
				}
			}
		}
	}

	switch (key)	{
		case Qt::Key_Down:
		case Qt::Key_Up: {
			if (m_curCtrl == 0) {
				bool find = false;
				QColor col;
				if (!m_colorList.isEmpty()){
					QList<QColor>::const_iterator  it = m_colorList.begin();
					int pos = 0;
					while(it != m_colorList.end()){
						col = *it;
						if (find){
							m_colorCur = col;
							m_colorCurPos = pos;
							break;
						}
						if (col == m_colorCur){
							find = true;
						}
						++pos;
						it++;
					}
					if (!find){
						m_colorCur = m_colorList[0];
						m_colorCurPos = 0;
					}
					update();
				}
			}
			break;
		}
		case Qt::Key_Escape:
		case Qt::Key_Enter:
		case Qt::Key_Return:
		{
			if (popupVisible()){
				popupHide();
				event->accept();
				return;
			}
			break;
		}


		case Qt::Key_Space:
		case Qt::Key_F4:
		{
			if (m_curCtrl != 0){
				btn = m_btns[m_curCtrl-1];
				if (btn) {
					btn->m_pressed = !btn->m_pressed;
					update();
				}
			} else {
				if (!popupVisible())
					popupShow();
				return;
			}
			break;
		}
		case Qt::Key_Right:
		case Qt::Key_Left:	{
			m_curCtrl += (key ==Qt::Key_Right)? 1 : -1;
			if (m_curCtrl<0) {
				m_curCtrl = m_addBtn;
			} else if (m_curCtrl>m_addBtn) {
				m_curCtrl = 0;
			}
			update();
			break;
		}


		default: {
			QFrame::keyPressEvent( event );
			break;
		}
	}
	if (btn)
		checkButtonAction(btn);


}

void uoColorChooser::focusInEvent ( QFocusEvent * event )
{
	m_curCtrl = 0;
	resetButton();
	update();
}

void uoColorChooser::focusOutEvent ( QFocusEvent * event )
{
	m_curCtrl = 0;
	QWidget* wi = QApplication::focusWidget();
	if (wi && wi != m_Container) {
		popupHide();
	}
	resetButton();
	update();
}

void uoColorChooser::mousePressEvent(QMouseEvent *event)
{
	QPoint pt = event->pos();
	event->accept();
	popupHide();
	bool find = false;
	m_curCtrl = 0;
	uoAddButton* btn = NULL;
	QList<uoAddButton*>::iterator it = m_btns.begin();
	while(it != m_btns.end()){
		btn = *it;
		++m_curCtrl;
		if (btn){
			if (btn->m_rect.contains(pt)) {
				btn->m_pressed = true;
				find = true;
				break;
			}
		}
		it++;
	}
	if (!find){
		m_curCtrl = 0;
	}
	update();
	if (find)
		checkButtonAction(btn);

}
void uoColorChooser::mouseReleaseEvent(QMouseEvent *event)
{
	event->accept();
	resetButton();
	update();
}

/// Надо попробовать поймать сигнал, который бы проинформировал о том, что надо спрятать попуп.
bool uoColorChooser::event ( QEvent * event )
{
	QEvent::Type t = event->type();
	if (t == QEvent::ZOrderChange) {
		if (popupVisible()){
			popupHide();
		}
	}
	return QFrame::event(event);
}

void uoColorChooser::hideEvent(QHideEvent *)
{
	popupHide();
}

void uoColorChooser::setupBotton()
{
	addButtonPrimitive(QStyle::PE_IndicatorArrowDown, uoBtn_showPalette);
    addButton("O", uoBtn_colorChoose);
    addButton("X", uoBtn_colorClear);
//  addButton("Open");
//  addButton("Open");

}


void uoColorChooser::popupShow()
{
	if (m_colorList.isEmpty())
		return;
	getContainer();
	QSize sz = m_Container->recalcSize();
	m_Container->doChangeCurColor(m_colorCurPos);

    QPoint below = mapToGlobal(frameRect().bottomLeft());
    QRect contRect = QRect(below, QPoint(below.x()+sz.width(), below.y()+sz.height()));
    m_Container->setGeometry(contRect);
    m_Container->move(below);
	m_Container->raise();
    m_Container->show();
    m_Container->update();
}

void uoColorChooser::popupHide()
{
	getContainer();
    m_Container->hide();
    resetButton();
}

bool uoColorChooser::popupVisible()
{

	if (m_Container){
		return m_Container->isVisible();
	}
	return false;
}


void uoColorChooser::resetButton()
{
	uoAddButton* btn = NULL;
	QList<uoAddButton*>::iterator it = m_btns.begin();
	while(it != m_btns.end()){
		btn = *it;
		if (btn)
			btn->m_pressed = false;
		it++;
	}
}

